#ifndef EMU_CPU_INSTRUCTION_H
#define EMU_CPU_INSTRUCTION_H

#include "../cpu_const.h"
#include "./ram.h"
#include "./register.h"
#include "./stack.h"
#include <stdbool.h>

#define LOG_INSTRUCTION_DATA

bool LogInstructionData(CpuInstructions instruction, ArgumentInfo arg1Info,
                        ArgumentInfo arg2Info, r16_int arg1, r16_int arg2,
                        r16_int arg1Val, r16_int arg2Val);
void ExecuteInstruction(CpuInstructions instruction, ArgumentInfo arg1Info,
                        ArgumentInfo arg2Info, r16_int arg1, r16_int arg2);

#endif